## zsync-curl 0.6.2-3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(zsync-curl LANGUAGES C)

add_subdirectory(src)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(zsync-curl LANGUAGES C)

add_definitions(-DPACKAGE="zsync_curl" -DVERSION="0.6.2")
set(CMAKE_C_STANDARD 99)

add_subdirectory(librcksum)
add_subdirectory(zlib)
add_subdirectory(libzsync)
#add_subdirectory(doc)

include(CheckSymbolExists)
include(CheckTypeSize)

check_symbol_exists(getaddrinfo "netdb.h" HAVE_GETADDRINFO)
CHECK_TYPE_SIZE(off_t SIZEOF_OFF_T)

add_definitions(-DSIZEOF_OFF_T=${SIZEOF_OFF_T})

add_executable(zsync_curl client.c http.c url.c progress.c base64.c)
set_target_properties(zsync_curl PROPERTIES OUTPUT_NAME "zsync")


if(HAVE_GETADDRINFO)
    target_compile_definitions(zsync_curl PRIVATE HAVE_GETADDRINFO=1)
endif()

target_link_libraries(zsync_curl
    PRIVATE
        Zsync::zsync
        Librcksum::librcksum
        Zlib::inflate
        Zlib::deflate
        curl
)

add_executable(zsyncmake_curl make.c makegz.c)
set_target_properties(zsyncmake_curl PROPERTIES OUTPUT_NAME "zsyncmake")
target_link_libraries(zsyncmake_curl
    PRIVATE
        Zsync::zsync
        Librcksum::librcksum
        Zlib::inflate
        Zlib::deflate
        m
)

install(
    TARGETS
        zsync_curl
        zsyncmake_curl
    RUNTIME DESTINATION
        bin
)

=== src/librcksum/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

include(CheckIncludeFile)
CHECK_INCLUDE_FILE("inttypes.h" HAVE_INTTYPES_H)

add_library(rcksum)
add_library(Librcksum::librcksum ALIAS rcksum)
target_sources(rcksum PRIVATE rsum.c hash.c state.c range.c md4.c ../zsglobal.h)
target_include_directories(rcksum
    PUBLIC
        ..
)

# TODO: as test
add_executable(md4test md4test.c md4.c)
target_include_directories(md4test
    PRIVATE
        ..
)

if(HAVE_INTTYPES_H)
    target_compile_definitions(rcksum PUBLIC HAVE_INTTYPES_H=1)
    target_compile_definitions(md4test PRIVATE HAVE_INTTYPES_H=1)
endif()

=== src/libzsync/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

include(CheckIncludeFile)
CHECK_INCLUDE_FILE("inttypes.h" HAVE_INTTYPES_H)

add_library(zsync)
add_library(Zsync::zsync ALIAS zsync)
target_sources(zsync PRIVATE zsync.h zsync.c zmap.c sha1.c)
target_include_directories(zsync
    PUBLIC
        ..
)

# TODO: as test
add_executable(sha1test sha1test.c sha1.c)
target_include_directories(sha1test
    PRIVATE
        ..
)

if(HAVE_INTTYPES_H)
    target_compile_definitions(zsync PRIVATE HAVE_INTTYPES_H=1)
    target_compile_definitions(sha1test PRIVATE HAVE_INTTYPES_H=1)
endif()

=== src/zlib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

include(CheckIncludeFile)
CHECK_INCLUDE_FILE("inttypes.h" HAVE_INTTYPES_H)

add_library(inflate)
add_library(Zlib::inflate ALIAS inflate)
target_sources(inflate PRIVATE inflate.c adler32.c inftrees.c zutil.c crc32.c)

add_library(deflate)
add_library(Zlib::deflate ALIAS deflate)
target_sources(deflate PRIVATE deflate.c compress.c trees.c)

=== debian/changelog ===
zsync-curl (0.6.2-3) stable; urgency=medium

  * Do not replace zsync, provide zsync-curl and zsyncmake-curl binaries

 -- Jan Schneider <j.schneider@uib.de>  Thu, 24 Feb 2022 10:11:00 +0100

zsync-curl (0.6.2-2) stable; urgency=medium

  * Provides and Replaces zsync

 -- Jan Schneider <j.schneider@uib.de>  Mon, 22 Feb 2022 20:00:00 +0100

zsync-curl (0.6.2-1) stable; urgency=medium

  * New upstream release.

 -- Jan Schneider <j.schneider@uib.de>  Mon, 21 Feb 2022 08:30:00 +0100

=== src/debian/changelog ===
zsync-curl (0.6.2-3) raring; urgency=low

  * Remove zsyncmake from build
  * Change binary name to zsync_curl

 -- Mike Heald <mike.heald@canonical.com>  Tue, 12 Feb 2012 16:48:07 -0000

zsync-curl (0.6.2-2) raring; urgency=low

  * Debian build configuration update

 -- Mike Heald <mike.heald@canonical.com>  Tue, 12 Feb 2012 13:34:07 -0000

zsync-curl (0.6.2-1) raring; urgency=low

  * Initial fork from zsync 0.6.2:
    - internal http client replaced with libcurl
    - added -c option to set cookie for all requests

 -- Mike Heald <mike.heald@canonical.com>  Mon, 11 Feb 2012 16:21:07 -0000

=== debian/control ===
Source: zsync-curl
Section: net
Priority: optional
Maintainer: uib GmbH <info@uib.de>
Build-Depends: debhelper (>= 10.0.0), cmake, automake, autoconf, libtool, libssl-dev, gcc, libcurl4-gnutls-dev, zlib1g-dev
Standards-Version: 4.1.3
Homepage: https://github.com/probonopd/zsync-curl

Package: zsync-curl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Partial/differential file download client over HTTP(S).
 Downloads a file over HTTP(S).
 zsync uses a control file to determine whether any blocks in the file are already known to the downloader, and only downloads the new blocks.
 This fork uses libcurl in order to support HTTPS and is mirrored from Launchpad.
 It has been further modified to respond more gracefully to redirects.

=== src/debian/control ===
Source: zsync-curl
Section: net
Priority: optional
Maintainer: Mike Heald <mike.heald@canonical.com>
Build-Depends: debhelper (>= 8.0.0), autotools-dev, libcurl4-openssl-dev
Standards-Version: 3.9.2
Homepage: https://github.com/probonopd/zsync-curl

Package: zsync-curl
Architecture: any
Suggests: zsync
Depends: ${shlibs:Depends}, ${misc:Depends}, libcurl3
Description: client-side implementation of the rsync algorithm
 zsync is a file transfer program to download files from
 remote web servers. If a previous version of a file is available
 locally, zsync will only download changed parts and hereby
 minimise the download volume. The algorithm is the same as used
 by rsync(1), but zsync does not require any server software
 (apart from a web server), nor does it need shell access.
 Instead, it uses a control file (.zsync file) that describes the
 file to be downloaded, which it uses to determine the blocks to
 fetch. This file is created once on the server (and not for each
 request) and sits next to actual file to download
 This version replaces the internal http client with libcurl.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_install:
	dh_install
	mv debian/zsync-curl/usr/bin/zsync debian/zsync-curl/usr/bin/zsync-curl
	mv debian/zsync-curl/usr/bin/zsyncmake debian/zsync-curl/usr/bin/zsyncmake-curl

=== src/debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# Site		Directory		Pattern			Version	Script
version=3
#http://code.launchpad.net/zsync-curl download/zsync-curl(.*)\.tar\..*
